package com.huiju.welcome.controller;


import com.huiju.welcome.common.base.BaseController;
import com.huiju.welcome.common.base.ResponseBean;
import com.huiju.welcome.model.TaFirstpageNotice;
import com.huiju.welcome.service.ITaFirstpageNoticeService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.http.HttpStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author jobob
 * @since 2019-03-12
 */
@RestController
@RequestMapping("/zys/ta-firstpage-notice")
public class TaFirstpageNoticeController extends BaseController {

    @Autowired
    private ITaFirstpageNoticeService taFirstpageNoticeService;

    @ApiOperation(value = "首屏公告映射", notes = "首屏公告映射")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "body", dataType = "Integer", name = "firstpageId", value = "首屏ID"),
            @ApiImplicitParam(paramType = "body", dataType = "Integer", name = "noticeId", value = "公告ID"),
            @ApiImplicitParam(paramType = "body", dataType = "Integer", name = "weight", value = "权重"),
    })
    @RequestMapping(value = "/firstpage_notice", method = RequestMethod.POST)
    public ResponseBean create(@RequestBody TaFirstpageNotice taFirstpageNotice, HttpServletRequest request) {
        ResponseBean responseBean = new ResponseBean();

        boolean success = taFirstpageNoticeService.save(taFirstpageNotice);
        if (!success) {
            responseBean.addError(HttpStatus.SC_INTERNAL_SERVER_ERROR, "新增内容失败, 请重试");
            return responseBean;
        }

        return responseBean;
    }


    @ApiOperation(value = "首屏公告映射删除", notes = "首屏公告映射删除")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", dataType = "Integer", name = "firstpageId", value = "首屏ID"),
            @ApiImplicitParam(paramType = "path", dataType = "Integer", name = "noticeId", value = "公告ID")
    })
    @RequestMapping(value = "/firstpage_content/firstpage/{firstpageId}/notice/{noticeId}", method = RequestMethod.DELETE)
    public ResponseBean delete(TaFirstpageNotice taFirstpageNotice, HttpServletRequest request) {
        ResponseBean responseBean = new ResponseBean();

        boolean success = taFirstpageNoticeService.remove(taFirstpageNotice);
        if (!success) {
            responseBean.addError(HttpStatus.SC_INTERNAL_SERVER_ERROR, "删除内容失败, 请重试");
            return responseBean;
        }

        return responseBean;
    }
}
